<?php
/*
Plugin Name: p01-contact
Description: Replace (% contact:me@exemple.com %) by a contact form
Version: 0.1
Author: Nicolas Liautaud
Author URI: http://nliautaud.fr
*/

# get correct id for plugin
$thisfile=basename(__FILE__, ".php");

# register plugin
register_plugin(
	$thisfile, 	# ID of plugin, should be filename minus php
	'p01-contact', 	# Title of plugin
	'0.1', 		# Version of plugin
	'Nicolas Liautaud',	# Author of plugin
	'http://nliautaud.fr', 	# Author URL
	'Replace (% contact:me@exemple.com %) tag by a contact form', 	# Plugin Description
	'plugins', 	# Page type of plugin
	''  	# Function that displays content
);

# activate filter
add_filter('content','content_p01contact');

/*
  Filter Content for adsense markers (%ad_id%)
    the add of that id will be inserted in the markers section of the conent
*/
function content_p01contact($contents) {
    $data = prepare_data($_POST['contact']);
    
    // send mail, display message
    if(!empty($data)) {
        if(send_message($data)) {
            echo '<div style="width:100%;border:1px solid green;color:green;padding:10px;margin:10px;background-color:#dfd;">Email sent.</div>';
        } else {
            echo'<div style="width:100%;border:1px solid red;color:red;padding:10px;margin:10px;background-color:#fdd;">Please enter at least your name, a valid email address and your message.</div>';
        }
    }
    // parse page content
    $tmpContent = $contents;
    preg_match_all('`\(% *contact *: *(.*) *%\)`',$tmpContent,$tmpArr);
    
    $AlltoReplace = $tmpArr[count($tmpArr)-1];
    $totalToReplace = count($AlltoReplace);
    for ($i=0;$i<$totalToReplace;$i++) {
        $tmpContent = preg_replace('`\(% *contact *: *.*%\)`',get_form($tmpArr[1][$i], $data),$tmpContent);
    }
    return $tmpContent;
}

function get_form($tget, $m) {
    
    $form  = '<h1>Formulaire</h1>';
    $form .= '<form action=".?id=contact" class="contactform" method="post"><table width="100%">';
    $form .= '    <tr><td><label for="name">Name <span style="color:#f00;">*</span> :</label></td><td><input id="name" name="contact[name]" type="text" value="' . (isset($m['name'])?$m['name']:'') . '" /></td></tr>';
    $form .= '    <tr><td><label for="email">Email <span style="color:#f00;">*</span> :</label></td><td><input id="email" name="contact[email]" type="text" value="' . (isset($m['email'])?$m['email']:'') . '" /></td></tr>';
    $form .= '    <tr><td><label for="address">Postal address :</label></td><td><textarea id="address" name="contact[address]" type="text" rows="2">' . (isset($m['address'])?$m['address']:'') . '</textarea></td></tr>';
    $form .= '    <tr><td><label for="phone">Phone number :</label></td><td><input id="phone" name="contact[phone]" type="text" value="' . (isset($m['phone'])?$m['phone']:'') . '" /></td></tr>';
    $form .= '    <tr><td><label for="subject">Subject :</label></td><td><input id="subject" name="contact[subject]" type="text" value="' . (isset($m['subject'])?$m['subject']:'') . '" /></td></tr>';
    $form .= '    <tr><td><label for="message">Message <span style="color:#f00;">*</span> :</label></td><td><textarea id="message" name="contact[message]" rows="10">' . (isset($m['message'])?$m['message']:'') . '</textarea></td></tr>';
    $form .= '    <input name="contact[tget]" type="hidden" value="' . $tget . '" /></p>';
    $form .= '    <tr><td></td><td><input class="submit" id="contact-submit" name="contact-submit" type="submit" value="Send" /></td></tr>';
    $form .= '</table></form>';
    return $form;
}

function send_message($m) {
    if(!empty($m['name']) && check_email($m['email']) && !empty($m['message'])) {
    
        $message .= '<h1>Message sent by ' . get_page_url(1) . '</h1>';
        $message .= '<ul><li>Date : ' . date('r') . '</li>';
        $message .= '<li>From : ' . $m['name'] . '</li>';
        $message .= '<li>Email : ' . $m['email'] . '</li>';
        if(!empty($m['phone']))   $message .= '<li>Phone number : ' . $m['phone'] . '</li>';
        if(!empty($m['address'])) $message .= '<li>Address : ' . $m['address'] . '</li>';
        $message .= '</ul><p>' . nl2br($m['message']) . '</p>';

        preg_match("`([^/]*)/(index\.php\?id=)?[^/=]+$`",get_page_url(1),$out);
        $sitename = $out[1];
        $subject = $m['subject'] . ' (sent from ' . $sitename . ')';
        
        $headers  = "From: ".$m['email']."\r\n";
        $headers .= "Reply-To: ".$m['email']."\r\n";
        $headers .= "Return-Path: ".$m['email']."\r\n";
        $headers .= "MIME-Version: 1.0\r\n";
        $headers .= "Content-type: text/html; charset=UTF-8\r\n";

        //mail($m['tget'],'=?UTF-8?B?'.base64_encode($subject).'?=',"$message",$headers);
        return 1;
    }
    return 0;
}

function check_email($e) {
    $pattern = "^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z]{2,3})$";
    if(eregi($pattern,$e)) {
        return 1;
    }
    return 0;
}

function prepare_data($array){
    foreach($array as $key => $val){
        $array[$key] = htmlentities(utf8_decode($val));
    }
    return $array;
}
